import { StrykerOptions } from '@stryker-mutator/api/core';
import { Logger } from '@stryker-mutator/api/logging';
import * as babel from './helpers/babelWrapper';
export interface StrykerBabelConfig {
    extensions: readonly string[];
    options: babel.TransformOptions;
    optionsFile: string | null;
    optionsApi?: Partial<babel.ConfigAPI>;
}
export declare const CONFIG_KEY = "babel";
export declare const FILE_KEY: keyof StrykerBabelConfig;
export declare const OPTIONS_KEY: keyof StrykerBabelConfig;
export declare const EXTENSIONS_KEY: keyof StrykerBabelConfig;
export declare class BabelConfigReader {
    private readonly log;
    static inject: ["logger"];
    constructor(log: Logger);
    readConfig(strykerOptions: StrykerOptions): StrykerBabelConfig;
    private readBabelOptionsFromFile;
}
//# sourceMappingURL=BabelConfigReader.d.ts.map