import { File, StrykerOptions } from '@stryker-mutator/api/core';
import { Injector, TranspilerPluginContext } from '@stryker-mutator/api/plugin';
import { Transpiler } from '@stryker-mutator/api/transpile';
import { BabelConfigReader } from './BabelConfigReader';
export declare function babelTranspilerFactory(injector: Injector<TranspilerPluginContext>): BabelTranspiler;
export declare namespace babelTranspilerFactory {
    var inject: ["$injector"];
}
export declare class BabelTranspiler implements Transpiler {
    private readonly babelConfig;
    private readonly projectRoot;
    private readonly extensions;
    static inject: ["options", "produceSourceMaps", "babelConfigReader"];
    constructor(options: StrykerOptions, produceSourceMaps: boolean, babelConfigReader: BabelConfigReader);
    transpile(files: readonly File[]): Promise<readonly File[]>;
    private transpileFileIfNeeded;
    private transpileFile;
    private determineProjectRoot;
}
//# sourceMappingURL=BabelTranspiler.d.ts.map